/*
iadn
http://www.iadn.narod.ru
iadn@bk.ru
*/
#include<stdio.h>
#include <libc/stubs.h>
#include <kosgl.h> //TinyGL
#include <string.h>

#include "loadmd2.h"
#include "pcx.h"


extern "C"{
long filelength(int fhandle);
}

md2_model_t* mdl_model[MAXLOADMODEL];
IMAGERGB*    irgb_text[MAXLOADMODEL];
int          NumModel = 0;


void NameText(char* nametext, char* fullnametext)
{
	  char* str;	  
	  int n = 0;
	  
	  str = fullnametext;
	  do{
		 if(*str == '/') n++;
		 str++;
	  }while(*str);
	  		  
	if(n>=1){
	  int len = strlen(fullnametext)+1;
	  str = new char[len];
	  char* str0 = str;	  
	  memset(str, 0, len); 
	  memcpy(str, fullnametext, len);
	  for(;*str;str++){};
	  for(;*str!='/';str--){};
	  str++;
	  memcpy(nametext, str, strlen(str)+1);
	  delete str0;
	  } 
}

char* ModelPathText(char* md2_name, char* text_name)
{
	  int n = 0;
	  int k = 0;	  
	  int len_md2;
	  int len_text_name;
	  char *fname_,*fname;
	  char *path_text,*path_text_;
	  char* text_name_;
	  	  
	  len_md2 = strlen(md2_name) + 1;
	  len_text_name = strlen(text_name);
	  fname = new char[len_md2];
	  fname_ = fname;
	  text_name_ = text_name;
	  memset(fname, 0, len_md2); 
	  memcpy(fname,md2_name,len_md2);
	   
 	  do{
	     if(*fname=='/') n++;
	     fname++;
	     }while(*fname);
	  
	  do{
	     if(*text_name=='/') k++;
	     text_name++;
	     }while(*fname);
	  text_name = text_name_; 
	  	  	  
 	  if(((n>1)||((n==1)&&(*fname_!='/')))&&(k<=1)){
			  do{
	     		 fname--;
	     		 }while(*fname!='/');
	  		  fname++; 
	  		  
	  		  int len_md2_name = strlen(fname);
	  		  int len_full = len_md2 - len_md2_name + len_text_name;

	  		  path_text = new char[len_full];
    		  memset(path_text, 0, len_full);
			  path_text_ = path_text;
			  fname = fname_;
			  
	  		  for(int i=0;i<len_md2 - len_md2_name-1;i++){
			  		*path_text = *fname;
			  		path_text++;
			  		fname++;
					}
			  len_text_name += 1;
			  if(k==1) text_name++;
			  for(int i=0;i<len_text_name;i++){
			  		*path_text = *text_name;
			  		path_text++;
			  		text_name++;
					}
			  }
	  else{	  	   
		   len_text_name += 1;
		   path_text_ = new char[len_text_name];
	  	   memcpy(path_text_,text_name,len_text_name);
		   }
		   
	  delete fname_;
	  
return	path_text_;  		  
}

void LoadMD2Model(char* md2_name, char* text_name)
{ 	
  if(NumModel<MAXLOADMODEL){
	mdl_model[NumModel] = new md2_model_t;
	md2_model_t* mdl = mdl_model[NumModel];
	IMAGERGB* irgb = irgb_text[NumModel];

	if(!ReadMD2Model(md2_name, mdl))
	return; 
	
	if(strlen(text_name)==0x0){
		md2_skin_t* skins = mdl->skins;	
		for(int i=0;i<mdl->header.num_skins;i++){ 
			NameText(skins->name, skins->name);
			skins++;
		    }
		if(!LoadPCX(ModelPathText(md2_name, mdl->skins->name), irgb))return;
        }
    else{
		 if(!LoadPCX(ModelPathText(md2_name, text_name), irgb))return;
		 }

	// generate texture object IDs 
 	glGenTextures(1, &mdl->tex_id);	
	glBindTexture(GL_TEXTURE_2D, mdl->tex_id);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, irgb->xsize, irgb->ysize, 0,
	    GL_RGB, GL_UNSIGNED_BYTE, irgb->image);    
	    
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT); 
 	 
 	NumModel++;
  }  
}

void LoadConfigFile(char* nameCF)//
{
 	 FILE *fp;
	 int fsize;
	 char *file, *file_, ch;
	 char  *name_md2, *name_text, *name_md2_, *name_text_;
	 	 
	 fp = fopen(nameCF,"rb");
	 if(!fp) return; 
	 fsize = filelength(fileno(fp));
	 file = new char[fsize];
	 file_ = file;

	 
	 name_md2 = new char[255];
	 name_text = new char[255];
	 name_md2_ = name_md2;
	 name_text_ = name_text;
	 *name_md2_  = 0x0;
     *name_text_ = 0x0;
	 
	 fread(file, fsize, 1, fp);
	 
	 for(int i=0; i<fsize; i++){
	 	   	 	     
	 	   switch(*file){
		   			case 0x20:
						 break;
		   			
		   			case 0x23:
						 do{
					 	 file++;
					 	 i++;
				         }while(*file!=0x0A);
						 break;
					
					case 0x0D:
						 break;	 
		   			
		   			case 0x0A:
						 break;		   			
		   			
		   			default:
					 		do{
					 	 		*name_md2 = *file;
		 	 		  			name_md2++;		 	 		  			
						 		file++;
					 	 		i++;
					 	 		
		     			    }while((*file!=0x0A)&&(*file!=0x0D)&&(*file!=0x20));

							*name_md2 = 0x0;

					 	   do{						   	
							switch(*file){
						   			case 0x20:
										 i++;
										 file++;
										 break;
						   			
									case 0x23:
						 				 do{
 	 				 					 file++;
					 	 				 i++;
				         				 }while(*file!=0x0A);
						 				 break;   									
									
									case 0x0D:
										 i++;
										 file++;
										 break;	 

						   			default:
									 		do{
									 	 		*name_text = *file;
						 	 		  			name_text++;
										 		file++;
									 	 		i++;
						     			    }while((*file!=0x0A)&&(*file!=0x0D)&&(*file!=0x20));
						     			    *name_text = 0x0;
											break;
									};
									}while(*file!=0x0A);
							break;
					};
		  if(strlen(name_md2_)!=0x0){
	           if(strlen(name_text_)!=0x0){
			        LoadMD2Model(name_md2_,name_text_);
			   }
			   else{
			   		LoadMD2Model(name_md2_,"");
					};
		 	   *name_md2_  = 0x0;
			   *name_text_ = 0x0;
			   name_md2 = name_md2_;
			   name_text = name_text_;			   
			   }
		   file++;
		   }

	 delete file_; 
	 delete name_md2_;
     delete name_text_;
	 fclose(fp); 
}
